# This is part of dview, a dvi previewer. (c) 1995 Thomas Moor          #
#                                                                       #
# This program may be used without any warranty. It may be modified and #
# distributed without any restrictions.                                 #

		.file "mem.S"

 # This file contains my special memcpy functions, avoiding some
 # trouble with my spea mirage. its all a dirty hack.
 # i Should have used vgagl or svgalib, but it just did not work.
 # ... and i should have read the first chapter of a 386 assemler 
 # language book.


 # Prototype: mymemcpyflip( long vgaoffset, void *src, int n )
 # Copies pixels from 1-byte-per-pixel mem to 1-byte-per-pixel screen,
 # changing some pixels. dest must be divisible by 4, to work
 # on spea mirage. on other hardware it wont work anyway.


.text   
	.align 4

.globl _mymemcpyflip
_mymemcpyflip:
	pushl %ebp
	movl %esp,%ebp
	subl $8,%esp	        #local var at ebp-4 and ebp-8
	pushl %edi
	pushl %esi
	pushl %ebx
	pushl %ecx
        pushl %edx


	#movl 8(%ebp),%edi	# destination offset
	#movl 12(%ebp),%esi	# source address
	#movl 16(%ebp),%ecx	# number of pixels

        #set vgapage
	movl 8(%ebp),%eax	# destination offset in eax
	shrl $16,%eax
	andl $0xF,%eax
	movl %eax,-4(%ebp)        # save pagenumber  at -4(%ebp)
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	movl 8(%ebp),%edi	# destination offset in edi
	andl $0xFFFF,%edi       # destination offset wrt page in edi
	movl %edi,%eax
	movl 16(%ebp),%ecx	# number of pixels
	addl %ecx,%eax          # %eax = off wrt page + pixels - 64K ...
	subl $0x10000,%eax	#  ... count to change page
	movl %eax,-8(%ebp)	#               ... at -8(%ebp)	
	addl _graph_mem,%edi    # destination address in edi	
	movl 12(%ebp),%esi	# source address
		
1:      # main loop
	
	# Handle chunks of 4 pixels.
        cmpl $4,%ecx
	jl 2f

	movl (%esi),%eax	# pixel 0,1,2,3
        movl %eax,%ebx
        andl $0x0000FF00,%ebx
        shll $8,%ebx            # pixel -,2,-,-
        movl %eax,%edx
        andl $0x00FF0000,%edx
        shrl $8,%edx            # pixel -,-,1,-
        andl $0xFF0000FF,%eax   # pixel 0,-,-,3
        orl  %ebx,%eax
        orl  %edx,%eax          # pixel 0,2,1,3
	 
	movl %eax,(%edi)	# write pixel 0,2,1,3
        #movl $8,(%edi)         # write shit for debugging
	addl $4,%edi
        addl $4,%esi
        subl $4,%ecx
	
	cmpl %ecx,-8(%ebp)      #time to change page ?
	jne 1b			# no .. loop on
	movl -4(%ebp),%eax      # yes:	 get current page
	incl %eax
	pushl %ecx
	pushl %esi
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	popl %esi
	popl %ecx
	movl _graph_mem,%edi    # dest adr = beginning of buffer
	movl $-4,-8(%ebp)	# dont do it again
	jmp 1b                  # loop on
	
2:	# Do the remaining pixels.

	andl %ecx,%ecx
	jz 6f			# none left
3:	movb (%esi),%eax        # first left
        movb %eax,(%edi)
        incl %esi
        incl %edi
	decl %ecx
	jz 6f
4:      incl (%edi)            # second left
	movb (%esi),%eax       
        movb %eax,(%edi)
        incl %esi
        decl %edi
	decl %ecx
	jz 6f
5:      movb (%esi),%eax       #third left, must be the last one
        movb %eax,(%edi)

6: 
        popl %edx
	popl %ecx
	popl %ebx
	popl %esi
	popl %edi
	addl $8,%esp
	popl %ebp
	ret



	
 # Prototype: mymemcpyflip4( long vgaoffset, void *src, int n )
 # Copies pixels from 4-bit-per-pixel mem to 1-byte-per-pixel screen,
 # changing some pixels. dest must be divisible by 4, to work
 # on spea mirage. on other hardware it wont work anyway.


.text   
	.align 4

.globl _mymemcpyflip4
_mymemcpyflip4:
	pushl %ebp
	movl %esp,%ebp
	subl $8,%esp	        #local var at ebp-4 and ebp-8
	pushl %edi
	pushl %esi
	pushl %ebx
	pushl %ecx
        pushl %edx

        #set vgapage
	movl 8(%ebp),%eax	# destination offset in eax
	shrl $16,%eax
	andl $0xF,%eax
	movl %eax,-4(%ebp)        # save pagenumber  at -4(%ebp)
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	movl 8(%ebp),%edi	# destination offset in edi
	andl $0xFFFF,%edi       # destination offset wrt page in edi
	movl %edi,%eax
	movl 16(%ebp),%ecx	# number of pixels in ecx
	addl %ecx,%eax          # %eax = off wrt page + pixels - 64K ...
	subl $0x10000,%eax	#  ... count to change page
	movl %eax,-8(%ebp)	#               ... at -8(%ebp)	
	addl _graph_mem,%edi    # destination address in edi	
	movl 12(%ebp),%esi	# source address in esi
	
1:      # main loop
	
	# Handle chunks of 4 pixels.
        cmpl $4,%ecx
	jl 2f
	
	movw (%esi),%eax	 # pixel 0,1,2,3
        movl %eax,%ebx
        andl $0xF,%ebx           
	shll $24,%ebx		 # pixel 3,-,-,-
	movl %eax,%edx
	andl $0xF0,%edx
        shll $4,%edx             # pixel -,-,2,-
	orl  %edx,%ebx
        movl %eax,%edx
	andl $0xF00,%edx
	shll $8,%edx	         # pixel -,1,-,-
	orl  %edx,%ebx
	movl %eax,%edx
        andl $0xF000,%edx
        shrl $12,%edx            # pixel -,-,-,0
	orl  %edx,%ebx           # pixel 3,1,2,0
	 
	movl %ebx,(%edi)	# write pixel 3,1,2,0
        #movl $0x08080808,(%edi)         # write shit for debugging
	addl $4,%edi
        addl $2,%esi
        subl $4,%ecx
	
	cmpl %ecx,-8(%ebp)      #time to change page ?
	jne 1b			# no ..
	movl -4(%ebp),%eax      # yes:	 get current page
	incl %eax
	pushl %ecx
	pushl %esi
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	popl %esi
	popl %ecx
	movl _graph_mem,%edi    # dest adr = beginning of buffer
	movl $-4,-8(%ebp)	# dont do it again
	jmp 1b
	

2:	# Do the remaining pixels.

	andl %ecx,%ecx
	jz 6f			# none left
3:	movw (%esi),%eax        # first left
	andl $0xF000,%eax
	shrl $12,%eax
        movb %eax,(%edi)
        incl %edi
	decl %ecx
	jz 6f
4:                              # second left
	movw (%esi),%eax       
        andl $0xF00,%eax
	shrl $8,%eax
	incl %edi
	movb %eax,(%edi)
	decl %edi
	decl %ecx
	jz 6f
5:      movw (%esi),%eax       #third left, must be the last one
        andl $0xF0,%eax
	shrl $4,%eax
        movb %eax,(%edi)

6:	 
        popl %edx
	popl %ecx
	popl %ebx
	popl %esi
	popl %edi
	addl $8,%esp
	popl %ebp
	ret



 # Prototype: mymemcpyflip1( long vgaoffset, void *src, int n, int skip )
 # Copies pixels from 1-bit-per-pixel mem to 1-byte-per-pixel screen,
 # changing some pixels. n must be dividible by 4. dest must be divisible 
 # by 4, to work on spea mirage. on other hardware it wont work anyway.
 # skip is the number of nibbles to skip in the first src word.


.text   
	.align 4

.globl _mymemcpyflip1
_mymemcpyflip1:
	pushl %ebp
	movl %esp,%ebp
	subl $8,%esp	        #local var at ebp-4 and ebp-8
	pushl %edi
	pushl %esi
	pushl %ebx
	pushl %ecx
        pushl %edx

        #set vgapage
	movl 8(%ebp),%eax	# destination offset in eax
	shrl $16,%eax
	andl $0xF,%eax
	movl %eax,-4(%ebp)        # save pagenumber  at -4(%ebp)
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	movl 8(%ebp),%edi	# destination offset in edi
	andl $0xFFFF,%edi       # destination offset wrt page in edi
	movl %edi,%eax
	movl 16(%ebp),%ecx	# number of pixels in ecx
	andl $0xFFFC,%ecx       # be shure its divisible by 4
	addl %ecx,%eax          # %eax = off wrt page + pixels - 64K ...
	subl $0x10000,%eax	#  ... count to change page
	movl %eax,-8(%ebp)	#               ... at -8(%ebp)	
	addl _graph_mem,%edi    # destination address in edi	
	movl 12(%ebp),%esi	# source address in esi
        movw (%esi),%eax	# pixel 0,1,2,3,4,5,6,7,8,9,a,b,c,d,e,f
	movl 20(%ebp),%ebx      # nibbles to skip ...
	cmpl $1,%ebx		# skip 1.
	je 2f			
	cmpl $2,%ebx		# skip 2.
	je 3f
	cmpl $3,%ebx		# skip 3.
	je 4f
		
1:      # main loop
	
	# Handle chunks of 16 pixels.
        
	andl %ecx,%ecx
	jz 6f
	movw (%esi),%eax	 # pixel 0,1,2,3,4,5,6,7,8,9,a,b,c,d,e,f
        movw %eax,%ebx
        andl $0x1000,%ebx           
	shll $12,%ebx		 # pixel 3,-,-,-
	movl %eax,%edx
	andl $0x2000,%edx
        shrl $5,%edx             # pixel -,-,2,-
	orl  %edx,%ebx
        movl %eax,%edx
	andl $0x4000,%edx
	shll $2,%edx	         # pixel -,1,-,-
	orl  %edx,%ebx
	movl %eax,%edx
        andl $0x8000,%edx
        shrl $15,%edx            # pixel -,-,-,0
	orl  %edx,%ebx           # pixel 3,1,2,0	 
	movl %ebx,(%edi)	 # write pixel 3,1,2,0
        #movl $0x08080808,(%edi) # write shit for debugging
	addl $4,%edi
	subl $4,%ecx
	jz 6f	                # did it !
	cmpl %ecx,-8(%ebp)	# time to change page ?
	jne  2f
	call 10f		# yes
	
2:	movw %eax,%ebx
        andl $0x100,%ebx           
	shll $16,%ebx		 # pixel 7,-,-,-
	movl %eax,%edx
	andl $0x200,%edx
        shrl $1,%edx             # pixel -,-,6,-
	orl  %edx,%ebx
        movl %eax,%edx
	andl $0x400,%edx
	shll $6,%edx	         # pixel -,5,-,-
	orl  %edx,%ebx
	movl %eax,%edx
        andl $0x800,%edx
        shrl $11,%edx            # pixel -,-,-,4
	orl  %edx,%ebx           # pixel 7,5,6,4	 
	movl %ebx,(%edi)	 # write pixel 
        #movl $0x08080808,(%edi) # write shit for debugging
	addl $4,%edi
	subl $4,%ecx
	jz 6f	                # did it !
	cmpl %ecx,-8(%ebp)	# time to change page ?
	jne  3f
	call 10f		# yes
	
3:	movw %eax,%ebx
        andl $0x10,%ebx           
	shll $20,%ebx		 # pixel b,-,-,-
	movl %eax,%edx
	andl $0x20,%edx
        shll $3,%edx             # pixel -,-,a,-
	orl  %edx,%ebx
        movl %eax,%edx
	andl $0x40,%edx
	shll $10,%edx	         # pixel -,9,-,-
	orl  %edx,%ebx
	movl %eax,%edx
        andl $0x80,%edx
        shrl $7,%edx            # pixel -,-,-,8
	orl  %edx,%ebx           # pixel b,9,a,8	 
	movl %ebx,(%edi)	 # write pixel 
        #movl $0x08080808,(%edi) # write shit for debugging
	addl $4,%edi
	subl $4,%ecx
	jz 6f	                # did it !
	cmpl %ecx,-8(%ebp)	# time to change page ?
	jne  4f
	call 10f		# yes
	
4:	movw %eax,%ebx
        andl $0x1,%ebx           
	shll $24,%ebx		 # pixel f,-,-,-
	movl %eax,%edx
	andl $0x2,%edx
        shll $7,%edx             # pixel -,-,e,-
	orl  %edx,%ebx
        movl %eax,%edx
	andl $0x4,%edx
	shll $14,%edx	         # pixel -,d,-,-
	orl  %edx,%ebx
	movl %eax,%edx
        andl $0x8,%edx
        shrl $3,%edx             # pixel -,-,-,c
	orl  %edx,%ebx           # pixel f,d,e,c	 
	movl %ebx,(%edi)	 # write pixel 
        #movl $0x08080808,(%edi) # write shit for debugging
	addl $4,%edi
	subl $4,%ecx
	jz 6f	                # did it !
	cmpl %ecx,-8(%ebp)	# time to change page ?
	jne  5f
	call 10f		# yes
	
5:	addl $2,%esi
	jmp 1b
	


6:	 
        popl %edx
	popl %ecx
	popl %ebx
	popl %esi
	popl %edi
	addl $8,%esp
	popl %ebp
	ret

10:     pushl %eax
	movl -4(%ebp),%eax      # get current page
	incl %eax
	pushl %ecx
	pushl %esi
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	popl %esi
	popl %ecx
	movl _graph_mem,%edi    # dest adr = beginning of buffer
	movl $-4,-8(%ebp)	# dont do it again
	popl %eax
	ret
	



 # Prototype: mymemcpystd( long vgaoffset, void *src, int n )
 # Copies pixels from 1-byte-per-pixel mem to 1-byte-per-pixel screen,
 # without changing some pixels. dest must be divisible by 4.


.text   
	.align 4

.globl _mymemcpystd
_mymemcpystd:
	pushl %ebp
	movl %esp,%ebp
	subl $8,%esp	        #local var at ebp-4 and ebp-8
	pushl %edi
	pushl %esi
	pushl %ebx
	pushl %ecx
        pushl %edx


	#movl 8(%ebp),%edi	# destination offset
	#movl 12(%ebp),%esi	# source address
	#movl 16(%ebp),%ecx	# number of pixels

        #set vgapage
	movl 8(%ebp),%eax	# destination offset in eax
	shrl $16,%eax
	andl $0xF,%eax
	movl %eax,-4(%ebp)        # save pagenumber  at -4(%ebp)
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	movl 8(%ebp),%edi	# destination offset in edi
	andl $0xFFFF,%edi       # destination offset wrt page in edi
	movl %edi,%eax
	movl 16(%ebp),%ecx	# number of pixels
	addl %ecx,%eax          # %eax = off wrt page + pixels - 64K ...
	subl $0x10000,%eax	#  ... count to change page
	movl %eax,-8(%ebp)	#               ... at -8(%ebp)	
	addl _graph_mem,%edi    # destination address in edi	
	movl 12(%ebp),%esi	# source address

	
	cld
1:      # main loop
	
	# Handle chunks of 4 pixels.
        cmpl $4,%ecx
	jl 2f

	movsb (%esi),(%edi)
	movsb (%esi),(%edi)
	movsb (%esi),(%edi)
	movsb (%esi),(%edi)
	subl $4,%ecx
	
	cmpl %ecx,-8(%ebp)      #time to change page ?
	jne 1b			# no ..
	movl -4(%ebp),%eax      # yes:	 get current page
	incl %eax
	pushl %ecx
	pushl %esi
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	popl %esi
	popl %ecx
	movl _graph_mem,%edi    # dest adr = beginning of buffer
	movl $-4,-8(%ebp)	# dont do it again
	jmp 1b
	

2:	# Do the remaining pixels.

	andl %ecx,%ecx
	jz 6f			# none left

3:	movsb (%esi),(%edi)     # first left
	decl %ecx
	jz 6f
4:	movsb (%esi),(%edi)     # second left
	decl %ecx
	jz 6f
5:      movsb (%esi),(%edi)      #third left, must be the last one

6:

	 
        popl %edx
	popl %ecx
	popl %ebx
	popl %esi
	popl %edi
	addl $8,%esp
	popl %ebp
	ret


 # Prototype: mymemcpystd4( long vgaoffset, void *src, int n )
 # Copies pixels from 4-bit-per-pixel mem to 1-byte-per-pixel screen.


.text   
	.align 4

.globl _mymemcpystd4
_mymemcpystd4:
	pushl %ebp
	movl %esp,%ebp
	subl $8,%esp	        #local var at ebp-4 and ebp-8
	pushl %edi
	pushl %esi
	pushl %ebx
	pushl %ecx
        pushl %edx

        #set vgapage
	movl 8(%ebp),%eax	# destination offset in eax
	shrl $16,%eax
	andl $0xF,%eax
	movl %eax,-4(%ebp)        # save pagenumber  at -4(%ebp)
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	movl 8(%ebp),%edi	# destination offset in edi
	andl $0xFFFF,%edi       # destination offset wrt page in edi
	movl %edi,%eax
	movl 16(%ebp),%ecx	# number of pixels in ecx
	addl %ecx,%eax          # %eax = off wrt page + pixels - 64K ...
	subl $0x10000,%eax	#  ... count to change page
	movl %eax,-8(%ebp)	#               ... at -8(%ebp)	
	addl _graph_mem,%edi    # destination address in edi	
	movl 12(%ebp),%esi	# source address in esi
	
1:      # main loop
	
	# Handle chunks of 4 pixels.
        cmpl $4,%ecx
	jl 2f
	
	movw (%esi),%eax	 # pixel 0,1,2,3
        movl %eax,%ebx
        andl $0xF,%ebx           
	shll $24,%ebx		 # pixel 3,-,-,-
	movl %eax,%edx
	andl $0xF0,%edx
        shll $12,%edx            # pixel -,2,-,-
	orl  %edx,%ebx
        movl %eax,%edx
	andl $0xF00,%edx
	#shll $8,%edx	         # pixel -,-,1,-
	orl  %edx,%ebx
	movl %eax,%edx
        andl $0xF000,%edx
        shrl $12,%edx            # pixel -,-,-,0
	orl  %edx,%ebx           # pixel 3,2,1,0
	 
	movl %ebx,(%edi)	# write pixel 3,1,2,0
        #movl $0x08080808,(%edi)         # write shit for debugging
	addl $4,%edi
        addl $2,%esi
        subl $4,%ecx
	
	cmpl %ecx,-8(%ebp)      #time to change page ?
	jne 1b			# no ..
	movl -4(%ebp),%eax      # yes:	 get current page
	incl %eax
	pushl %ecx
	pushl %esi
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	popl %esi
	popl %ecx
	movl _graph_mem,%edi    # dest adr = beginning of buffer
	movl $-4,-8(%ebp)	# dont do it again
	jmp 1b
	

2:	# Do the remaining pixels.

	andl %ecx,%ecx
	jz 6f			# none left
3:	movw (%esi),%eax        # first left
	andl $0xF000,%eax
	shrl $12,%eax
        movb %eax,(%edi)
        incl %edi
	decl %ecx
	jz 6f
4:                              # second left
	movw (%esi),%eax       
        andl $0xF00,%eax
	shrl $8,%eax
	movb %eax,(%edi)
	incl %edi
	decl %ecx
	jz 6f
5:      movw (%esi),%eax       #third left, must be the last one
        andl $0xF0,%eax
	shrl $4,%eax
        movb %eax,(%edi)

6:	 
        popl %edx
	popl %ecx
	popl %ebx
	popl %esi
	popl %edi
	addl $8,%esp
	popl %ebp
	ret


 # Prototype: mymemcpystd1( long vgaoffset, void *src, int n, int skip )
 # Copies pixels from 1-bit-per-pixel mem to 1-byte-per-pixel screen,
 # n must be divisible by 4.


.text   
	.align 4

.globl _mymemcpystd1
_mymemcpystd1:
	pushl %ebp
	movl %esp,%ebp
	subl $8,%esp	        #local var at ebp-4 and ebp-8
	pushl %edi
	pushl %esi
	pushl %ebx
	pushl %ecx
        pushl %edx

        #set vgapage
	movl 8(%ebp),%eax	# destination offset in eax
	shrl $16,%eax
	andl $0xF,%eax
	movl %eax,-4(%ebp)        # save pagenumber  at -4(%ebp)
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	movl 8(%ebp),%edi	# destination offset in edi
	andl $0xFFFF,%edi       # destination offset wrt page in edi
	movl %edi,%eax
	movl 16(%ebp),%ecx	# number of pixels in ecx
	andl $0xFFFC,%ecx       # be shure its divisible by 4
	addl %ecx,%eax          # %eax = off wrt page + pixels - 64K ...
	subl $0x10000,%eax	#  ... count to change page
	movl %eax,-8(%ebp)	#               ... at -8(%ebp)	
	addl _graph_mem,%edi    # destination address in edi	
	movl 12(%ebp),%esi	# source address in esi
        movw (%esi),%eax	# pixel 0,1,2,3,4,5,6,7,8,9,a,b,c,d,e,f
	movl 20(%ebp),%ebx      # nibbles to skip ...
	cmpl $1,%ebx		# skip 1.
	je 2f			
	cmpl $2,%ebx		# skip 2.
	je 3f
	cmpl $3,%ebx		# skip 3.
	je 4f
		
1:      # main loop
	
	# Handle chunks of 16 pixels.
        
	andl %ecx,%ecx
	jz 6f
	movw (%esi),%eax	 # pixel 0,1,2,3,4,5,6,7,8,9,a,b,c,d,e,f
        movw %eax,%ebx
        andl $0x1000,%ebx           
	shll $12,%ebx		 # pixel 3,-,-,-
	movl %eax,%edx
	andl $0x2000,%edx
        shll $3,%edx             # pixel -,2,-,-
	orl  %edx,%ebx
        movl %eax,%edx
	andl $0x4000,%edx
	shrl $6,%edx	         # pixel -,-,1,-
	orl  %edx,%ebx
	movl %eax,%edx
        andl $0x8000,%edx
        shrl $15,%edx            # pixel -,-,-,0
	orl  %edx,%ebx           # pixel 3,2,1,0	 
	movl %ebx,(%edi)	 # write pixel 3,2,1,0
        #movl $0x08080808,(%edi) # write shit for debugging
	addl $4,%edi
	subl $4,%ecx
	jz 6f	                # did it !
	cmpl %ecx,-8(%ebp)	# time to change page ?
	jne  2f
	call 10f		# yes
	
2:	movw %eax,%ebx
        andl $0x100,%ebx           
	shll $16,%ebx		 # pixel 7,-,-,-
	movl %eax,%edx
	andl $0x200,%edx
        shll $7,%edx             # pixel -,6,-,-
	orl  %edx,%ebx
        movl %eax,%edx
	andl $0x400,%edx
	shrl $2,%edx	         # pixel -,-,5,-
	orl  %edx,%ebx
	movl %eax,%edx
        andl $0x800,%edx
        shrl $11,%edx            # pixel -,-,-,4
	orl  %edx,%ebx           # pixel 7,6,5,4	 
	movl %ebx,(%edi)	 # write pixel 
        #movl $0x08080808,(%edi) # write shit for debugging
	addl $4,%edi
	subl $4,%ecx
	jz 6f	                # did it !
	cmpl %ecx,-8(%ebp)	# time to change page ?
	jne  3f
	call 10f		# yes
	
3:	movw %eax,%ebx
        andl $0x10,%ebx           
	shll $20,%ebx		 # pixel b,-,-,-
	movl %eax,%edx
	andl $0x20,%edx
        shll $11,%edx             # pixel -,a,-,-
	orl  %edx,%ebx
        movl %eax,%edx
	andl $0x40,%edx
	shll $2,%edx	         # pixel -,-,9,-
	orl  %edx,%ebx
	movl %eax,%edx
        andl $0x80,%edx
        shrl $7,%edx            # pixel -,-,-,8
	orl  %edx,%ebx           # pixel b,a,9,8	 
	movl %ebx,(%edi)	 # write pixel 
        #movl $0x08080808,(%edi) # write shit for debugging
	addl $4,%edi
	subl $4,%ecx
	jz 6f	                # did it !
	cmpl %ecx,-8(%ebp)	# time to change page ?
	jne  4f
	call 10f		# yes
	
4:	movw %eax,%ebx
        andl $0x1,%ebx           
	shll $24,%ebx		 # pixel f,-,-,-
	movl %eax,%edx
	andl $0x2,%edx
        shll $15,%edx             # pixel -,e,-,-
	orl  %edx,%ebx
        movl %eax,%edx
	andl $0x4,%edx
	shll $6,%edx	         # pixel -,-,d,-
	orl  %edx,%ebx
	movl %eax,%edx
        andl $0x8,%edx
        shrl $3,%edx             # pixel -,-,-,c
	orl  %edx,%ebx           # pixel f,e,d,c	 
	movl %ebx,(%edi)	 # write pixel 
        #movl $0x08080808,(%edi) # write shit for debugging
	addl $4,%edi
	subl $4,%ecx
	jz 6f	                # did it !
	cmpl %ecx,-8(%ebp)	# time to change page ?
	jne  5f
	call 10f		# yes
	
5:	addl $2,%esi
	jmp 1b
	


6:	 
        popl %edx
	popl %ecx
	popl %ebx
	popl %esi
	popl %edi
	addl $8,%esp
	popl %ebp
	ret

10:     pushl %eax
	movl -4(%ebp),%eax      # get current page
	incl %eax
	pushl %ecx
	pushl %esi
	pushl %eax
	call _vga_setpage
	addl $4,%esp
	popl %esi
	popl %ecx
	movl _graph_mem,%edi    # dest adr = beginning of buffer
	movl $-4,-8(%ebp)	# dont do it again
	popl %eax
	ret
	
















